VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   930
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   3315
   LinkTopic       =   "Form1"
   ScaleHeight     =   930
   ScaleWidth      =   3315
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   735
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2020
'
' Das ist nur ein Beispiel/Testcode! Fr entsprechende Infos zu den Interfaces, die
' hier im Beispiel verwendet werden, und wie das ganze funktioniert, bitte die
' Media Foundation Doku lesen!
'
' In diesem Beispiel wird nur das Prinzip gezeigt wie aus einer beliebigen, von der
' Media Foundation untersttzten, Audio- oder Video-Datei die sich in einem IStream
' befindet, zu einer Audio-Datei konvertiert werden kann.

Option Explicit

Private Sub Command1_Click()

    Dim FNr As Long
    Dim cbWrite As Long
    Dim cbWritten As Long
    Dim pIStream As Long
    Dim bolRet As Boolean
    Dim Buffer() As Byte
    
    bolRet = False
    
    ' Stream erstellen
    pIStream = SHCreateMemStream(0&, 0&)
    
    If pIStream <> 0& Then
    
        FNr = FreeFile
        
        Open App.Path & "\test.wav" For Binary Access Read As #FNr
        
            cbWrite = LOF(FNr)
            
            ReDim Buffer(cbWrite - 1)
            
            ' Datei in das Bytearray kopieren
            Get #FNr, , Buffer
            
        Close #FNr
        
        ' Bytearray in den Stream schreiben
        If Invoke(pIStream, Write_Stream, VarPtr(Buffer(0)), cbWrite, _
            VarPtr(cbWritten)) = S_OK Then
            
            ' Media Foundation starten
            If MFStartup(MF_VERSION, MF_STARTUP_FULL) = S_OK Then
            
                ' Stream encodieren
                ' als Test eine Wave zu MP3
                If EncodeStream(pIStream, "audio/wav", _
                    App.Path & "\test.mp3") = True Then
                    
                    bolRet = True
                    
                End If
                
                ' Media Foundation beenden
                Call MFShutdown
                
            End If
            
        End If
        
        ' Stream lschen
        Call Release(pIStream)
        
    End If
    
    If bolRet = True Then
        
        MsgBox "Fertig, alles ok.", vbInformation
        
    Else
    
        MsgBox "Ups, da hat was nicht geklappt.", vbCritical
    
    End If

End Sub
